*$ CREATE SOURCE.FOR
*COPY SOURCE
*
*=== source ===========================================================*
*
      SUBROUTINE SOURCE ( NOMORE )
c
c      DOUBLE PRECISION EK,W,X,Y,Z,TX,TY,TZ,SX,SY,SZ,T
c      INTEGER IDPDG
c
      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'
*    Need to know when is the last simulation to close the file
      INCLUDE '(CASLIM)'
*----------------------------------------------------------------------*
*                                                                      *
*     Copyright (C) 1990-2010      by    Alfredo Ferrari & Paola Sala  *
*     All Rights Reserved.                                             *
*                                                                      *
*                                                                      *
*     New source for FLUKA9x-FLUKA20xy:                                *
*                                                                      *
*     Created on 07 January 1990   by    Alfredo Ferrari & Paola Sala  *
*                                                   Infn - Milan       *
*                                                                      *
*     Last change on  17-Oct-10    by    Alfredo Ferrari               *
*                                                                      *
*  This is just an example of a possible user written source routine.  *
*  note that the beam card still has some meaning - in the scoring the *
*  maximum momentum used in deciding the binning is taken from the     *
*  beam momentum.  Other beam card parameters are obsolete.            *
*                                                                      *
*       Output variables:                                              *
*                                                                      *
*              Nomore = if > 0 the run will be terminated              *
*                                                                      *
*----------------------------------------------------------------------*
*
      INCLUDE '(BEAMCM)'
      INCLUDE '(FHEAVY)'
      INCLUDE '(FLKSTK)'
      INCLUDE '(IOIOCM)'
      INCLUDE '(LTCLCM)'
      INCLUDE '(PAPROP)'
      INCLUDE '(SOURCM)'
      INCLUDE '(SUMCOU)'
*
      LOGICAL LFIRST
*
      SAVE LFIRST
      DATA LFIRST / .TRUE. /
      DOUBLE PRECISION WEIGHT
      SAVE WEIGHTTOTAL
      DATA WEIGHTTOTAL /0.D0/
      INTERFACE
       SUBROUTINE read_init() BIND(C)
         USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT
         IMPLICIT NONE
       END SUBROUTINE read_init
       FUNCTION getno() BIND(C)
         USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT
         IMPLICIT NONE
         INTEGER (C_INT) :: getno
       END FUNCTION getno
      SUBROUTINE read_circled(EK,W,X,Y,Z,TX,TY,TZ,SX,SY,SZ,T,ID) BIND(C)
         USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT
         IMPLICIT NONE
         DOUBLE PRECISION EK,W,X,Y,Z,TX,TY,TZ,SX,SY,SZ,T
         INTEGER ID
      END SUBROUTINE read_circled
       FUNCTION read_do() BIND(C)
         USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT
         IMPLICIT NONE
         INTEGER(C_INT) :: read_do
       END FUNCTION read_do
       SUBROUTINE read_stop() BIND(C)
         USE, INTRINSIC :: ISO_C_BINDING, ONLY: C_INT
         IMPLICIT NONE
       END SUBROUTINE read_stop
      END INTERFACE
*======================================================================*
*                                                                      *
*                 BASIC VERSION                                        *
*                                                                      *
*======================================================================*
      NOMORE = 0
*  +-------------------------------------------------------------------*
*  |  First call initializations:
      IF ( LFIRST ) THEN
*  |  *** The following 3 cards are mandatory ***
         TKESUM = ZERZER
         LFIRST = .FALSE.
         LUSSRC = .TRUE.
*  |  *** User initialization ***
      CALL read_init()
      NFILE = getno ()
      WEIGHTTOTAL = NCASES / (ONEONE*NFILE)
      WRITE(LUNOUT,*) 'Message from SOURCE.F: MCPL source called'
      WRITE(LUNOUT,*) 'Message from SOURCE.F: NCASES=', NCASES ,
     & ' NFILE=',NFILE
      WRITE(LUNOUT,*) 'Message from SOURCE.F: Total primary weight used'
     & ,WEIGHTTOTAL
      END IF
*  |
*  +-------------------------------------------------------------------*
*  Reading particle from a file
      EK=0
      IDPDG=0 !READING NEUTRONS ONLY
      W=0
      X=0
      Y=0
      Z=0
      TX=0
      TY=0
      TZ=0
      SX=0
      XY=0
      SZ=0
      T=0
      DO WHILE (IDPDG.NE.2112)
      CALL read_circled(EK,W,X,Y,Z,TX,TY,TZ,SX,SY,SZ,T,IDPDG)
      END DO
*     WRITE(LUNOUT,*) 'Read particle',IDPDG,' with EK=',EK,'Z=',Z
*  Push one source particle to the stack. Note that you could as well
*  push many but this way we reserve a maximum amount of space in the
*  stack for the secondaries to be generated
*  Npflka is the stack counter: of course any time source is called it
*     must be =0
      NPFLKA = NPFLKA + 1
*  Wt is the weight of the particle
      WTFLK  (NPFLKA) = W
      WEIPRI = WEIGHTTOTAL
*  Particle type (1=proton.....). Ijbeam is the type set by the BEAM
*  card
         IONID = 8
         ILOFLK (NPFLKA) = 8
*  |  Flag this is prompt radiation
         LRADDC (NPFLKA) = .FALSE.
*  |  Group number for "low" energy neutrons, set to 0 anyway
         IGROUP (NPFLKA) = 0
*  |
*  +-------------------------------------------------------------------*
*  From this point .....
*  Particle generation (1 for primaries)
      LOFLK  (NPFLKA) = 1
*  User dependent flag:
      LOUSE  (NPFLKA) = 0
*  No channeling:
      LCHFLK (NPFLKA) = .FALSE.
      DCHFLK (NPFLKA) = ZERZER
*  User dependent spare variables:
      DO 100 ISPR = 1, MKBMX1
         SPAREK (ISPR,NPFLKA) = ZERZER
 100  CONTINUE
*  User dependent spare flags:
      DO 200 ISPR = 1, MKBMX2
         ISPARK (ISPR,NPFLKA) = 0
 200  CONTINUE
*  Save the track number of the stack particle:
      ISPARK (MKBMX2,NPFLKA) = NPFLKA
      NPARMA = NPARMA + 1
      NUMPAR (NPFLKA) = NPARMA
      NEVENT (NPFLKA) = 0
      DFNEAR (NPFLKA) = +ZERZER
*  ... to this point: don't change anything
*  Particle age (s)
      AGESTK (NPFLKA) = T*1.D-3 ! Value read from file is in ms
      AKNSHR (NPFLKA) = -TWOTWO
*  Kinetic energy of the particle (GeV)
      TKEFLK (NPFLKA) = EK*1.0D-3 !From MeV to GeV
*  Particle momentum
      PMOFLK (NPFLKA) = SQRT ( TKEFLK (NPFLKA) * ( TKEFLK (NPFLKA)
     &                       + TWOTWO * AM (IONID) ) )
*  Cosines (tx,ty,tz)
      TXFLK  (NPFLKA) = -TX
      TYFLK  (NPFLKA) = TZ
      TZFLK  (NPFLKA) = TY
*     TZFLK  (NPFLKA) = SQRT ( ONEONE - TXFLK (NPFLKA)**2
*    &                       - TYFLK (NPFLKA)**2 )
*  Polarization cosines:
      TXPOL  (NPFLKA) = -SX
      TYPOL  (NPFLKA) = SZ
      TZPOL  (NPFLKA) = SY
*  Particle coordinates
      XFLK   (NPFLKA) = -X+WHASOU(1)
      YFLK   (NPFLKA) = Z+WHASOU(2)
      ZFLK   (NPFLKA) = Y +WHASOU(3)
*      WRITE(LUNOUT,*) 'Message from SOURCE.F: X=',XFLK(NPFLKA)
*      WRITE(LUNOUT,*) 'Message from SOURCE.F: Y=',YFLK(NPFLKA)
*      WRITE(LUNOUT,*) 'Message from SOURCE.F: Z=',ZFLK(NPFLKA)
*  If it was the last sampling, close the file 
      IF (NCASE.EQ.NCASES) CALL read_stop()
*  Calculate the total kinetic energy of the primaries: don't change
      IF ( ILOFLK (NPFLKA) .EQ. -2 .OR. ILOFLK (NPFLKA) .GT. 100000 )
     &   THEN
         TKESUM = TKESUM + TKEFLK (NPFLKA) * WTFLK (NPFLKA)
      ELSE IF ( ILOFLK (NPFLKA) .NE. 0 ) THEN
         TKESUM = TKESUM + ( TKEFLK (NPFLKA) + AMDISC (ILOFLK(NPFLKA)) )
     &          * WTFLK (NPFLKA)
      ELSE
         TKESUM = TKESUM + TKEFLK (NPFLKA) * WTFLK (NPFLKA)
      END IF
      RADDLY (NPFLKA) = ZERZER
*  Here we ask for the region number of the hitting point.
*     NREG (NPFLKA) = ...
*  The following line makes the starting region search much more
*  robust if particles are starting very close to a boundary:
      CALL GEOCRS ( TXFLK (NPFLKA), TYFLK (NPFLKA), TZFLK (NPFLKA) )
      CALL GEOREG ( XFLK  (NPFLKA), YFLK  (NPFLKA), ZFLK  (NPFLKA),
     &              NRGFLK(NPFLKA), IDISC )
*  Do not change these cards:
      CALL GEOHSM ( NHSPNT (NPFLKA), 1, -11, MLATTC )
      NLATTC (NPFLKA) = MLATTC
      CMPATH (NPFLKA) = ZERZER
      CALL SOEVSV
      RETURN
*=== End of subroutine Source =========================================*
      END

